local addon, shared = ...

---------------------
-- Variables
---------------------

_castbarreplacement = {}

local PrevCastbar = Inspect.Unit.Castbar("player")
local Remaining = 0
local Couner = 0
local xPixels = 240
local yPixels = 32

local fHeight = yPixels
local fWidth = xPixels

_castbarreplacement.configMode = false
_castbarreplacement.configModeBar = "INT"

local defaults = {
	x=(UIParent:GetWidth()-xPixels)/2, y=(UIParent:GetHeight()-yPixels)/2,
	scale=1,
	m="FILL",
	tsize=17,
	details="",
	cols={
		bi_r=0,
		bi_g=0.3,
		bi_b=0.52,
		bu_r=0.9,
		bu_g=0.8,
		bu_b=0.2,
		ti_r=1,
		ti_g=0.95,
		ti_b=0,
		tu_r=1,
		tu_g=0,
		tu_b=0
	},
		alpha={
		bi=1,
		ti=1,
		bu=1,
		tu=1,
		bar=0.75
	},
	nl=1,
	bd="Y",
	bg="Y",
	texture="N",
	texturename="LiteStep.tga",
	truncate="N",
	align="C",
	dp=2,
	chnl="Y",
	sz="DEFAULT",
	custom = {
		sx=120,
		sy=120
	}
}

local adelea = {align = "C",alpha = {bar = 0.8,bi = 0.75,bu = 1,ti = 1,tu = 1},
bd = "Y",chnl = "y",cols = {bi_b = 0.5,bi_g = 0,bi_r = 0,bu_b = 0,bu_g = 0.42,bu_r = 1,ti_b = 1,ti_g = 1,ti_r = 1,tu_b = 1,tu_g = 1,tu_r = 1},
custom = {sx = 120,sy = 120},details = "rt",dp = 2,m = "DEPLETE",nl = 1,scale = 1.5,sz = "DEFAULT",
t = "TARGET",texture = "Y",truncate = "N",tsize = 12,x = 908.75012207031,y = 1009.7500610352, texturename="LiteStep.tga"}

local CBRBU_Settings = {}

-- Set defaults for saved variables
if (not CBR_Settings) then
	CBR_Settings = defaults
end

if (not CBR_Profiles) then
	CBR_Profiles = {}
end

---------------------
-- Utilities
---------------------

function _castbarreplacement.Resize()
	if CBR_Settings.sz == "DEFAULT" then
		fWidth = xPixels*CBR_Settings.scale
		fHeight = yPixels*CBR_Settings.scale
		_castbarreplacement.CBRFrame.text:SetFontSize(CBR_Settings.tsize*CBR_Settings.scale)
	else
		fWidth = CBR_Settings.custom.sx
		fHeight = CBR_Settings.custom.sy
		_castbarreplacement.CBRFrame.text:SetFontSize(CBR_Settings.tsize)
	end
	_castbarreplacement.CBRFrame:SetWidth(fWidth)
	_castbarreplacement.CBRFrame:SetHeight(fHeight)
	_castbarreplacement.CBRFrameTexture:SetWidth(fWidth)
	_castbarreplacement.CBRFrameTexture:SetHeight(fHeight)
	_castbarreplacement.CBRFrame.solid:SetHeight(fHeight)
	_castbarreplacement.CBRFrame.background:SetWidth(fWidth)
	_castbarreplacement.CBRFrame.background:SetHeight(fHeight)
	_castbarreplacement.CBRFrame.borderT:SetHeight(2)
	_castbarreplacement.CBRFrame.borderT:SetWidth(fWidth+4)
	_castbarreplacement.CBRFrame.borderB:SetHeight(2)
	_castbarreplacement.CBRFrame.borderB:SetWidth(fWidth+4)
	_castbarreplacement.CBRFrame.borderL:SetHeight(fHeight+4)
	_castbarreplacement.CBRFrame.borderL:SetWidth(2)
	_castbarreplacement.CBRFrame.borderR:SetHeight(fHeight+4)
	_castbarreplacement.CBRFrame.borderR:SetWidth(2)
end

function _castbarreplacement.SetupFrames()
	_castbarreplacement.context = UI.CreateContext("CBR")
	_castbarreplacement.CBRFrame = UI.CreateFrame("Frame", "_castbarreplacement.CBRFrame", _castbarreplacement.context)
	_castbarreplacement.CBRFrameTexture = UI.CreateFrame("Texture", "_castbarreplacement.CBRFrame", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrameTexture:SetTexture("CBR", "LiteStep.tga")

	_castbarreplacement.CBRFrame:SetLayer(0)
	_castbarreplacement.CBRFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	_castbarreplacement.CBRFrame:SetAlpha(CBR_Settings.alpha.bar)
	_castbarreplacement.CBRFrame:SetVisible(false)

	_castbarreplacement.CBRFrameTexture:SetPoint("CENTER", _castbarreplacement.CBRFrame, "CENTER", 0,0)
	_castbarreplacement.CBRFrameTexture:SetLayer(-3)

	_castbarreplacement.CBRFrame.borderT = UI.CreateFrame("Frame", "BorderT", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.borderT:SetLayer(-5)
	_castbarreplacement.CBRFrame.borderT:SetPoint("TOPLEFT", _castbarreplacement.CBRFrame, "TOPLEFT", -2,-2)
	_castbarreplacement.CBRFrame.borderT:SetBackgroundColor(0,0,0,0.75)

	_castbarreplacement.CBRFrame.borderL = UI.CreateFrame("Frame", "BorderL", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.borderL:SetLayer(-5)
	_castbarreplacement.CBRFrame.borderL:SetPoint("TOPLEFT", _castbarreplacement.CBRFrame, "TOPLEFT", -2,-2)
	_castbarreplacement.CBRFrame.borderL:SetBackgroundColor(0,0,0,0.75)

	_castbarreplacement.CBRFrame.borderB = UI.CreateFrame("Frame", "BorderB", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.borderB:SetLayer(-5)
	_castbarreplacement.CBRFrame.borderB:SetPoint("BOTTOMRIGHT", _castbarreplacement.CBRFrame, "BOTTOMRIGHT", 2,2)
	_castbarreplacement.CBRFrame.borderB:SetBackgroundColor(0,0,0,0.75)

	_castbarreplacement.CBRFrame.borderR = UI.CreateFrame("Frame", "BorderR", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.borderR:SetLayer(-5)
	_castbarreplacement.CBRFrame.borderR:SetPoint("BOTTOMRIGHT", _castbarreplacement.CBRFrame, "BOTTOMRIGHT", 2,2)
	_castbarreplacement.CBRFrame.borderR:SetBackgroundColor(0,0,0,0.75)

	_castbarreplacement.CBRFrame.text = UI.CreateFrame("Text", "Text", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.text:SetLayer(1)
	_castbarreplacement.CBRFrame.text:SetFontSize(20)
	_castbarreplacement.CBRFrame.text:SetVisible(true)

	_castbarreplacement.CBRFrame.solid = UI.CreateFrame("Frame", "Solid", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.solid:SetLayer(-1)  -- Put it behind every other element.
	_castbarreplacement.CBRFrame.solid:SetPoint("TOPLEFT", _castbarreplacement.CBRFrame, "TOPLEFT", 0,0)
	_castbarreplacement.CBRFrame.solid:SetVisible(true)

	_castbarreplacement.CBRFrame.background = UI.CreateFrame("Frame", "Background", _castbarreplacement.CBRFrame)
	_castbarreplacement.CBRFrame.background:SetLayer(-2)  -- Put it behind every other element.
	_castbarreplacement.CBRFrame.background:SetPoint("TOPLEFT", _castbarreplacement.CBRFrame, "TOPLEFT", 0,0)
	_castbarreplacement.CBRFrame.background:SetVisible(true)

-- movement code stolen/adapted from MinUI, which credits Gumaden.
	function _castbarreplacement.CBRFrame.Event:LeftDown()
		if not _castbarreplacement.configMode then
			return
		end
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.sx = mouseData.x - _castbarreplacement.CBRFrame:GetLeft()
		self.sy = mouseData.y - _castbarreplacement.CBRFrame:GetTop()
	end

	function _castbarreplacement.CBRFrame.Event:MouseMove()
		if not _castbarreplacement.configMode then
			return
		end
		if self.MouseDown then
			local nx, ny
			mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			_castbarreplacement.CBRFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
		end
	end

	function _castbarreplacement.CBRFrame.Event:LeftUp()
		if not _castbarreplacement.configMode then
			return
		end
		if self.MouseDown then
			self.MouseDown = false
		end
		CBR_Settings.x = _castbarreplacement.CBRFrame:GetLeft()
		CBR_Settings.y = _castbarreplacement.CBRFrame:GetTop()
	end
end

---------------------
-- Slash Commands
---------------------

function _castbarreplacement.SlashHandler(args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		r[numargs] = token
		numargs=numargs+1
	end
	if numargs>0 then
		if r[0] == "scale" then
			if numargs == 1 then
				if CBR_Settings.sz == "CUSTOM" then
					CBR_Settings.sz = "DEFAULT"
					_castbarreplacement.Resize()
					print "Reverting to scaled barsize mode"
				else
					print("Current scale = "..CBR_Settings.scale)
				end
			else
				local n = tonumber(r[1])
				if n and n > 0 then
					CBR_Settings.scale = n
					_castbarreplacement.Resize()
				else
					print("That is not a number...")
				end
			end
			return
		end
		if r[0] == "fill" then
			CBR_Settings.m = "FILL"
			print("Now filling castbar as spell progresses")
			return
		end
		if r[0] == "deplete" then
			CBR_Settings.m = "DEPLETE"
			print("Now emptying castbar as spell progresses")
			return
		end
		if r[0] == "textsize" then
			if numargs == 1 then
				print("CBR Text size scale = "..CBR_Settings.tsize)
			else
				local n = tonumber(r[1])
				if n and n > 0 then
					CBR_Settings.tsize = n
					_castbarreplacement.Resize()
				else
					print("That is not a number...")
				end
			end
			return
		end
		if r[0] == "remain/total" then
			CBR_Settings.details = "rt"
			print("Will show remaining and total time with spell name")
			return
		end
		if r[0] == "remain" then
			CBR_Settings.details = "r"
			print("Will show remaining time with spell name")
			return
		end
		if r[0] == "total" then
			CBR_Settings.details = "t"
			print("Will show total time with spell name")
			return
		end
		if r[0] == "nameonly" then
			CBR_Settings.details = ""
			print("Will show spell name only")
			return
		end
		if r[0] == "col" then
			if (numargs==5) or (numargs==6) then
				local cr,cg,cb,ca,tt,ti,ta
				cr=tonumber(r[2])
				cg=tonumber(r[3])
				cb=tonumber(r[4])
				if numargs==6 then
					ca=tonumber(r[5])
					if (not ca) or (ca<=0 or ca>1) then
						print "Alpha must be >0 and <=1"
						return
					end
					ta=string.format(",a=%.2f", ca)
				else
					ca=nil
					ta=""
				end
				if cr and cg and cb and cr>=0 and cr<=1 and cg>=0 and cg<=1 and cb>=0 and cb<=1 then
					if r[1] == "bi" then
						CBR_Settings.cols.bi_r=cr
						CBR_Settings.cols.bi_g=cg
						CBR_Settings.cols.bi_b=cb
						tt="bar"
						ti=""
						if ca then
							CBR_Settings.alpha.bi = ca
						end
					elseif r[1] == "bu" then
						CBR_Settings.cols.bu_r=cr
						CBR_Settings.cols.bu_g=cg
						CBR_Settings.cols.bu_b=cb
						tt="bar"
						ti="non-"
						if ca then
							CBR_Settings.alpha.bu = ca
						end
					elseif r[1] == "ti" then
						CBR_Settings.cols.ti_r=cr
						CBR_Settings.cols.ti_g=cg
						CBR_Settings.cols.ti_b=cb
						tt="text"
						ti=""
						if ca then
							CBR_Settings.alpha.ti = ca
						end
					elseif r[1] == "tu" then
						CBR_Settings.cols.tu_r=cr
						CBR_Settings.cols.tu_g=cg
						CBR_Settings.cols.tu_b=cb
						tt="text"
						ti="non-"
						if ca then
							CBR_Settings.alpha.tu = ca
						end
					else
						print "\t/cbr col bi|ti|bu|tu R G B [A]"
						return
					end
					print(string.format("Setting %s color for %sinterruptible spells to (r=%.2f,g=%.2f,b=%.2f%s)", tt, ti, cr,cg,cb,ta))
				else
					print "\t/cbr col bi|ti|bu|tu R G B [A]"
				end
			else
				print "\t/cbr col bi|ti|bu|tu R G B [A]"
			end
			return
		end
		if r[0] == "reset" then
			CBR_Settings = {}
			CBR_Settings = _MiscUtility.CopyTable(defaults)
			_castbarreplacement.Resize()
			return
		end
		if r[0] == "tcbimport" then
			local x = CBR_Settings.x
			local y = CBR_Settings.y
			if not TCB_Settings then
				print "Cannot find TCB Settings to import"
				return
			end
			CBR_Settings = {}
			CBR_Settings = _MiscUtility.CopyTable(TCB_Settings)
			CBR_Settings.x = x
			CBR_Settings.y = y
			_castbarreplacement.Resize()
			return
		end
		if r[0] == "lines" then
			if CBR_Settings.nl == 1 then
				CBR_Settings.nl = 2
				print("Displaying castbar text over 2 lines")
			else
				CBR_Settings.nl = 1
				print("Displaying castbar text on 1 line")
			end
			return
		end
		if r[0] == "channel" then
			if CBR_Settings.chnl == "Y" then
				print "Channeled spells operate the same as non-channeled"
				CBR_Settings.chnl = "N"
			else
				print "Channeled spells operate in reverse of non-channeled"
				CBR_Settings.chnl = "Y"
			end
			return
		end
		if r[0] == "border" then
			if CBR_Settings.bd == "Y" then
				print "Now hiding border"
				CBR_Settings.bd = "N"
			else
				print "Now showing border"
				CBR_Settings.bd = "Y"
			end
			_castbarreplacement.CBRFrame.borderT:SetVisible((CBR_Settings.bd=="Y"))
			_castbarreplacement.CBRFrame.borderB:SetVisible((CBR_Settings.bd=="Y"))
			_castbarreplacement.CBRFrame.borderL:SetVisible((CBR_Settings.bd=="Y"))
			_castbarreplacement.CBRFrame.borderR:SetVisible((CBR_Settings.bd=="Y"))
			return
		end
		if r[0] == "background" then
			local m
			if CBR_Settings.bg == "Y" then
				m = "Now hiding background"
				CBR_Settings.bg = "N"
			else
				m = "Now showing background"
				CBR_Settings.bg = "Y"
			end
			if CBR_Settings.texture == "Y" then
				m = m.." (and texture)"
			end
			print (m)
			_castbarreplacement.CBRFrame.background:SetVisible((CBR_Settings.bg == "Y"))
			_castbarreplacement.CBRFrameTexture:SetVisible((CBR_Settings.texture == "Y") and (CBR_Settings.bg == "Y"))
			return
		end
		if r[0] == "texture" then
			if CBR_Settings.texture == "Y" then
				print "Now using plain bar."
				CBR_Settings.texture = "N"
			else
				print "Now using textured bar."
				CBR_Settings.texture = "Y"
			end			
			_castbarreplacement.CBRFrameTexture:SetVisible((CBR_Settings.texture == "Y") and (CBR_Settings.bg == "Y"))
			return
		end
		if r[0] == "truncate" then
			if CBR_Settings.truncate == "Y" then
				print "Allowing bar text to overflow when required."
				CBR_Settings.truncate = "N"
			else
				print "Truncating bar text when required."
				CBR_Settings.truncate = "Y"
			end
			return
		end
		if r[0] == "align" then
			if not r[1] then
				print("Current alignment mode: "..CBR_Settings.align)
				return
			end
			if r[1] == "L" then
				CBR_Settings.align = "L"
				_castbarreplacement.CBRFrame.text:ClearPoint("CENTER")
				_castbarreplacement.CBRFrame.text:ClearPoint("CENTERRIGHT")
				_castbarreplacement.CBRFrame.text:SetPoint("CENTERLEFT", _castbarreplacement.CBRFrame, "CENTERLEFT",0,0)
				print "Aligning text to LEFT"
			elseif r[1] == "C" then
				CBR_Settings.align = "C"
				_castbarreplacement.CBRFrame.text:ClearPoint("CENTERLEFT")
				_castbarreplacement.CBRFrame.text:ClearPoint("CENTERRIGHT")
				_castbarreplacement.CBRFrame.text:SetPoint("CENTER", _castbarreplacement.CBRFrame, "CENTER",0,0)
				print "Aligning text to CENTER"
			elseif r[1] == "R" then
				CBR_Settings.align = "R"
				_castbarreplacement.CBRFrame.text:ClearPoint("CENTER")
				_castbarreplacement.CBRFrame.text:ClearPoint("CENTERLEFT")
				_castbarreplacement.CBRFrame.text:SetPoint("CENTERRIGHT", _castbarreplacement.CBRFrame, "CENTERRIGHT",0,0)
				print "Aligning text to RIGHT"
			else
				print("Unknown alignment mode: "..r[1])
			end
			return
		end
		if r[0] == "alpha" then
			if numargs==2 then
				local ca = tonumber(r[1])
				if ca and ca>0 and ca<=1 then
					CBR_Settings.alpha.bar = ca
					_castbarreplacement.CBRFrame:SetAlpha(CBR_Settings.alpha.bar)
					print("Setting overall alpha to "..ca)
				else
					print "Alpha must be >0 and <=1"
				end
			else
				print("Current alpha="..CBR_Settings.alpha.bar)
			end
			return
		end
		if r[0] == "prec" then
			if numargs==2 then
				local dp = tonumber(r[1])
				if dp==0 or dp==1 or dp==2 then
					CBR_Settings.dp = dp
					print("Setting precision to "..dp.." decimal places")
				else
					print "Precision must be 0,1 or 2"
				end
			else
				print("Current precision = "..CBR_Settings.dp.." decimal places")
			end
			return
		end
		if r[0] == "custom" then
			if numargs == 3 then
				local sx, sy
				sx = tonumber(r[1])
				sy = tonumber(r[2])
				if sx and sy then
					print("Setting bar to "..sx.." x "..sy.." pixels")
					CBR_Settings.sz = "CUSTOM"
					CBR_Settings.custom.sx = sx
					CBR_Settings.custom.sy = sy
					_castbarreplacement.Resize()
				else
					print "Invalid values"
				end
			else
				print "Custom requires an X and a Y value"
			end
			return
		end	
		if r[0] == "config" then
			if numargs == 1 then
				_castbarreplacement.configMode = not _castbarreplacement.configMode
			end
			if not _castbarreplacement.configMode then
				_castbarreplacement.CBRFrame:SetVisible(false)
				CastBar=nil
			end
			if numargs == 2 then
				if r[1] == "int" then
					_castbarreplacement.configModeBar = "INT"
				elseif r[1] == "nonint" then
					_castbarreplacement.configModeBar = "UNT"
				else
					print "Unknown bar to display"
					return
				end
			end
			return
		end
		if r[0] == "saveprofile" then
			if numargs == 2 then
				local pn = r[1]
				CBR_Profiles[pn] = {}
				CBR_Profiles[pn] = _MiscUtility.CopyTable(CBR_Settings)
				print ("Saving current settings as profilename: "..pn)
			else
				print ("Usage: saveprofile PROFILENAME")
			end
			return
		end
		if r[0] == "listprofile" then
			if not CBR_Profiles then
				print ("You have no saved profiles.")
				return
			end
			local c = 1
			for k,_ in pairs(CBR_Profiles) do
				print (c..": Profilename: "..k)
				c=c+1
			end
			if (c==1) then
				print ("You have no saved profiles.")
			end
			return
		end
		if r[0] == "loadprofile" then
			if numargs == 2 then
				local pn = r[1]
				if CBR_Profiles[pn] then			
					print ("attempting to loadprofile: "..pn)
					CBR_Settings = {}
					CBR_Settings = _MiscUtility.CopyTable(CBR_Profiles[pn])
					_castbarreplacement.Resize()
					_castbarreplacement.CBRFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", CBR_Settings.x, CBR_Settings.y)
				else
					print ("Profilename: "..pn.." does not exist")
				end
			else
				print ("Usage: loadprofile PROFILENAME")
			end
			return
		end		
		if r[0] == "undo" then
			CBR_Settings = {}
			CBR_Settings = _MiscUtility.CopyTable(CBRBU_Settings)
			_castbarreplacement.Resize()
			return
		end
		if r[0] == "adelea" then
			CBR_Settings = {}
			CBR_Settings = _MiscUtility.CopyTable(adelea)
			_castbarreplacement.Resize()
			return
		end
	end
	print "CBR:"
	print "\t/cbr config - displays static bar on screen to see changes"
	print "\t/cbr scale #.## - scales the bar size up or down by the given amount"
	print "\t/cbr custom X Y - Overrides scale and sets bar to X by Y pixels"
	print "\t/cbr fill|deplete - changes the way the castbar moves (empty->full, or full->empty)"
	print "\t/cbr truncate - Toggles truncation of bartext as required"
-- added by Kalvir 	(Zelandonii on Steampike).
	print "\t/cbr textsize ## - changes the text size"
	print "\t/cbr remain/total - Shows cast remaining and total time"
	print "\t/cbr remain - Shows cast remaining time"
	print "\t/cbr total - Shows cast total time"
	print "\t/cbr nameonly - Shows only the ability name"
-- end
	print "\t/cbr lines - Toggles display between 1 and 2 lines"
	print "\t/cbr prec 0|1|2 - Sets number of decimal places to display on times"
	print "\t/cbr align L C R - Aligns bar text to Left/Center/Right"
	print "\t/cbr col bi|ti|bu|tu R G B - set the color of the bars or text"
	print "\tt[b=bar, t=text, i=interruptible, u=non-interruptible, R/G/B are numbers from 0-1"
	print "\t/cbr alpha # - Sets overall alpha (Range 0-1)"
	print "\t/cbr channel - Toggles channeled spell reversal"
	print "\t/cbr border - Toggles display of border"
	print "\t/cbr background - Toggles display of background"
	print "\t/cbr texture - Toggles use of textured bar"
	print "\t/cbr listprofile - Lists all saved profiles"
	print "\t/cbr loadprofile NAME - Loads the profile saved as NAME"
	print "\t/cbr saveprofile NAME - Saves the current active settings as NAME"	
	print "\t/cbr reset - resets all options to defaults"
	print "\t/cbr undo - restores settings to how they were at loadtime"
	print "\t/cbr tcbimport - imports settings from TCB"
end

---------------------
-- Event Handlers
---------------------

function _castbarreplacement.OnUpdate()
	local CastBar

	if _castbarreplacement.configMode then
		CastBar = {
			uninterruptible = false,
			abilityName = "CB Configuration Mode",
			duration = 12,
			remaining = 3,
			channeled = false,
		}
		if _castbarreplacement.configModeBar == "UNT" then
			CastBar.uninterruptible = true
		end
	else
		CastBar = Inspect.Unit.Castbar("player")
	end
	
	if CastBar then
		-- Do stuff that doesn't change during the cast only once:
		if not(CastBar == PrevCastbar) then
			if CastBar.uninterruptible then
				local br,bg,bb,ba
				br=CBR_Settings.cols.bu_r
				bg=CBR_Settings.cols.bu_g
				bb=CBR_Settings.cols.bu_b
				ba=CBR_Settings.alpha.bu
				_castbarreplacement.CBRFrame.solid:SetBackgroundColor(br,bg,bb,ba)
				_castbarreplacement.CBRFrame.background:SetBackgroundColor(br/4,bg/4,bb/4,ba*0.75)
				br=CBR_Settings.cols.tu_r
				bg=CBR_Settings.cols.tu_g
				bb=CBR_Settings.cols.tu_b
				ba=CBR_Settings.alpha.tu
				_castbarreplacement.CBRFrame.text:SetFontColor(br,bg,bb)
				_castbarreplacement.CBRFrame.text:SetAlpha(ba)
			else
				local br,bg,bb,ba
				br=CBR_Settings.cols.bi_r
				bg=CBR_Settings.cols.bi_g
				bb=CBR_Settings.cols.bi_b
				ba=CBR_Settings.alpha.bi
				_castbarreplacement.CBRFrame.solid:SetBackgroundColor(br,bg,bb,ba)
				_castbarreplacement.CBRFrame.background:SetBackgroundColor(br/4,bg/4,bb/4,ba*0.75)
				br=CBR_Settings.cols.ti_r
				bg=CBR_Settings.cols.ti_g
				bb=CBR_Settings.cols.ti_b
				ba=CBR_Settings.alpha.ti
				_castbarreplacement.CBRFrame.text:SetFontColor(br,bg,bb)
				_castbarreplacement.CBRFrame.text:SetAlpha(ba)
			end
			-- Deal with unchanging text:
			if CBR_Settings.details == "" or CBR_Settings.details == "t" then
				if CBR_Settings.details == "" then
					_castbarreplacement.CBRFrame.text:SetText((CastBar.abilityName or "UNKNOWN SPELL"))
				end
				if CBR_Settings.details == "t" then
					local d
					local sep = '\n'
					if CBR_Settings.dp == 0 then
						d = string.format("[%d]", CastBar.duration)
					elseif CBR_Settings.dp == 1 then
						d = string.format("[%.1f]", CastBar.duration)
					else
						d = string.format("[%.2f]", CastBar.duration)
					end				
					if CBR_Settings.nl == 1 then
						sep = ' '
					end
					_castbarreplacement.CBRFrame.text:SetText(string.format("%s%s%s", (CastBar.abilityName or "UNKNOWN SPELL"), sep, d))
				end
				-- Center the text:
				_castbarreplacement.CBRFrame.text:ClearWidth()
				if (_castbarreplacement.CBRFrame.text:GetWidth() > fWidth) and (CBR_Settings.truncate == "Y") then
					_castbarreplacement.CBRFrame.text:SetWidth(fWidth)
				end
			end

			Couner = 0
			_castbarreplacement.CBRFrame:SetVisible(true)
			_castbarreplacement.CBRFrame.solid:SetAlpha(0.5)

			PrevCastbar = CastBar
		end

		-- Deal with changing text:
		if CBR_Settings.details == "rt" or CBR_Settings.details == "r" then
			if CBR_Settings.details == "rt" then
				local d
				local sep = '\n'
				if CBR_Settings.dp == 0 then
					d = string.format("[%d/%d]", CastBar.remaining, CastBar.duration)
				elseif CBR_Settings.dp == 1 then
					d = string.format("[%.1f/%.1f]", CastBar.remaining, CastBar.duration)
				else
					d = string.format("[%.2f/%.2f]", CastBar.remaining, CastBar.duration)
				end							
				if CBR_Settings.nl == 1 then
					sep = ' '
				end
				_castbarreplacement.CBRFrame.text:SetText(string.format("%s%s%s", (CastBar.abilityName or "UNKNOWN SPELL"), sep, d))
			end
			if CBR_Settings.details == "r" then
				local d
				local sep = '\n'
				if CBR_Settings.dp == 0 then
					d = string.format("[%d]", CastBar.remaining)
				elseif CBR_Settings.dp == 1 then
					d = string.format("[%.1f]", CastBar.remaining)
				else
					d = string.format("[%.2f]", CastBar.remaining)
				end					
				if CBR_Settings.nl == 1 then
					sep = ' '
				end
				_castbarreplacement.CBRFrame.text:SetText(string.format("%s%s%s", (CastBar.abilityName or "UNKNOWN SPELL"), sep, d))
			end
			-- Center the text:
			_castbarreplacement.CBRFrame.text:ClearWidth()
			if (_castbarreplacement.CBRFrame.text:GetWidth() > fWidth) and (CBR_Settings.truncate == "Y") then
				_castbarreplacement.CBRFrame.text:SetWidth(fWidth)
			end
		end
		-- Update the bar progress:
		Remaining = CastBar.remaining
		local Done = Remaining/CastBar.duration
		if CBR_Settings.m == "FILL" then
			if CastBar.channeled and CBR_Settings.chnl == "Y" then
				_castbarreplacement.CBRFrame.solid:SetWidth(fWidth*Done)
			else
				_castbarreplacement.CBRFrame.solid:SetWidth(fWidth*(1-Done))
			end
		else
			if CastBar.channeled and CBR_Settings.chnl == "Y" then
				_castbarreplacement.CBRFrame.solid:SetWidth(fWidth*(1-Done))
			else
				_castbarreplacement.CBRFrame.solid:SetWidth(fWidth*Done)
			end
		end
	else
		if Remaining < 0.06 and Couner == 0 then	-- Last spell completed and we're not showing 'Interrupted' fadeout?
			_castbarreplacement.CBRFrame:SetVisible(false)
			_castbarreplacement.CBRFrame.text:ClearPoint("CENTERLEFT")
			_castbarreplacement.CBRFrame.text:ClearPoint("CENTERRIGHT")
			_castbarreplacement.CBRFrame.text:ClearPoint("CENTER")
			local align
			if CBR_Settings.align == "L" then
				align="CENTERLEFT"
			elseif CBR_Settings.align == "R" then
				align="CENTERRIGHT"
			else
				align="CENTER"
			end
			_castbarreplacement.CBRFrame.text:SetPoint(align, _castbarreplacement.CBRFrame, align, 0,0)

		else	-- Last spell was interrupted:
			-- Show 'Interrupted' with fadeout:
			_castbarreplacement.CBRFrame.solid:SetBackgroundColor(1,0.27,0.27,1)
			_castbarreplacement.CBRFrame.text:SetFontColor(1, 1, 1)
			_castbarreplacement.CBRFrame.text:SetText("Interrupted")

			_castbarreplacement.CBRFrame.text:ClearWidth()
			_castbarreplacement.CBRFrame.text:ClearPoint("CENTERLEFT")
			_castbarreplacement.CBRFrame.text:ClearPoint("CENTERRIGHT")
			_castbarreplacement.CBRFrame.text:SetPoint("CENTER", _castbarreplacement.CBRFrame, "CENTER", 0,0)	
			_castbarreplacement.CBRFrame.solid:SetWidth(fWidth)

			if Couner == 0 then	-- We're starting the fadeout?
				Couner = 10
			else	-- We're in the fadeout:
				Couner = Couner-1
				_castbarreplacement.CBRFrame.solid:SetAlpha(Couner/20)
			end
			Remaining = 0	-- Clear 'Interrupted' detection.
		end
		PrevCastbar = nil	-- Update tracking var.
	end
end

function _castbarreplacement.VariablesLoaded(a)
	if not (a == "CBR") then
		return
	end
	_MiscUtility.MergeTable(CBR_Settings, defaults)
	CBRBU_Settings = _MiscUtility.CopyTable(CBR_Settings)

	_castbarreplacement.SetupFrames()
	_castbarreplacement.Resize()
	_castbarreplacement.CBRFrame:ClearPoint("CENTER")
	_castbarreplacement.CBRFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", CBR_Settings.x, CBR_Settings.y)
	_castbarreplacement.CBRFrame.borderT:SetVisible((CBR_Settings.bd == "Y"))
	_castbarreplacement.CBRFrame.borderL:SetVisible((CBR_Settings.bd == "Y"))
	_castbarreplacement.CBRFrame.borderB:SetVisible((CBR_Settings.bd == "Y"))
	_castbarreplacement.CBRFrame.borderR:SetVisible((CBR_Settings.bd == "Y"))
	local align
	if CBR_Settings.align == "L" then
		align="CENTERLEFT"
	elseif CBR_Settings.align == "R" then
		align="CENTERRIGHT"
	else
		align="CENTER"
	end
	_castbarreplacement.CBRFrame.text:SetPoint(align, _castbarreplacement.CBRFrame, align, 0,0)
	_castbarreplacement.CBRFrame.background:SetVisible((CBR_Settings.bg == "Y"))
	_castbarreplacement.CBRFrameTexture:SetTexture("CBR", CBR_Settings.texturename)
	_castbarreplacement.CBRFrameTexture:SetVisible((CBR_Settings.texture == "Y") and (CBR_Settings.bg == "Y"))

	table.insert(Event.System.Update.Begin, { _castbarreplacement.OnUpdate, addon.identifier, "Event.System.Update.Begin" })

	if (not CBR_Profiles) then
		CBR_Profiles = {}
	end
end

---------------------
-- Register Events
---------------------

table.insert(Event.Addon.SavedVariables.Load.End, { _castbarreplacement.VariablesLoaded, addon.identifier, "Event.Addon.SavedVariables.Load.End" })
table.insert(Command.Slash.Register("cbr"), { _castbarreplacement.SlashHandler, addon.identifier, "Command.Slash.Register" })

print(string.format("v%s loaded. Type /cbr to see options.", addon.toc.Version))
