------------------------------------------------
------------------------------------------------
--                                            --
--   ConquestTracker                          --
--                                            --
--   Charakter: Matti@Brutwacht               --
--   E-Mail: MatthiasHenning@HobbySoldat.de   --
--                                            --
------------------------------------------------
------------------------------------------------

-- LanguageSelect
local sysLanguage = Inspect.System.Language()
if (sysLanguage ~= "English" and sysLanguage ~= "German" and sysLanguage ~= "French") then
	sysLanguage = "English"
end

-- LanguageFiles
local language = {}
language["English"] = {}
language["German"] = {}
language["French"] = {}

-- English
language["English"].conquest_message_last5minutes="Stillmoor will be Conquered in 5 minutes!"

-- German
language["German"].conquest_message_last5minutes="Stillmoor wird in 5 Minuten erobert!"

-- French
language["French"].conquest_message_last5minutes="Mornelande sera conquise dans 5 minutes !"

-- EU oder US
local realmpool = nil
local shard = Inspect.Shard().name

if (shard == "Akala" or shard == "Argent" or shard == "Blightweald" or shard == "Bloodiron" or shard == "Brisesol" or shard == "Brutmutter" or shard == "Brutwacht" or shard == "Icewatch" or shard == "Phynnious" or shard == "Tr\195\188bkopf") then
	realmpool = "EU"
elseif (shard == "Deepwood" or shard == "Faeblight" or shard == "Greybriar" or shard == "Laethys" or shard == "Seastone" or shard == "Shatterbone" or shard == "Threesprings" or shard == "Wolfsbane") then
	realmpool = "US"
else
	--print("Realmpool could not be found. Functionality is limited.")
end

-- Channel deaktiviert
realmpool = nil

-- Standardschriftart festlegen
-- local font = "Ubuntu-C.ttf"
-- local fontSource = "ConquestTracker"

-- Variablen
local window_visible = 1
local blocker = 0
local blockerConquest = 0
local waiter = 0
local addon_messageId = "CQT001"
local addon_state = "on"
local addon_global = false
local updater = 0
local dom = 0
local nf = 0
local oath = 0
local kills = 0
local timer = 0
local timer2 = 0
local animation_red = false
local animation_fadeIn = false
local animation_fadeOut = false
local timer_conquestEnd = Inspect.Time.Server()
local standbytimer = Inspect.Time.Real()
local context = UI.CreateContext("CQTC")

local window = UI.CreateFrame("Texture", "Icon", context)
window:SetTexture("ConquestTracker", "window.png")
window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 350, 350)
window:SetLayer(3)
window:SetVisible(true)

--timer_conquestEnd = Inspect.Time.Server()
--kills = 9999



local window_shadow_red = UI.CreateFrame("Texture", "Icon", context)
window_shadow_red:SetTexture("ConquestTracker", "window_shadow_red.png")
window_shadow_red:SetPoint("CENTER", window, "CENTER", 0, 0)
window_shadow_red:SetAlpha(0)
window_shadow_red:SetLayer(0)
window_shadow_red:SetVisible(true)

window_shadow_red.animationDirection = "+"
local update_animation = 0

local percent_size = 16

local icon_dom = UI.CreateFrame("Texture", "Icon", context)
icon_dom:SetTexture("ConquestTracker", "dom_small.png")
icon_dom:SetPoint("CENTER", window, "TOPLEFT", math.floor(183/2)-55, math.floor(89/2)+9)
icon_dom:SetLayer(1)

local icon_nf = UI.CreateFrame("Texture", "Icon", context)
icon_nf:SetTexture("ConquestTracker", "nf_small.png")
icon_nf:SetPoint("CENTER", window, "TOPLEFT", math.floor(183/2), math.floor(89/2)+9)
icon_nf:SetLayer(1)

local icon_oath = UI.CreateFrame("Texture", "Icon", context)
icon_oath:SetTexture("ConquestTracker", "oath_small.png")
icon_oath:SetPoint("CENTER", window, "TOPLEFT", math.floor(183/2)+55, math.floor(89/2)+9)
icon_oath:SetLayer(1)

local text_cqt = UI.CreateFrame("Text", "CQTC", context)
text_cqt:SetPoint("CENTER", window, "CENTER", 0, -50)
text_cqt:SetText("")
text_cqt:SetLayer(5)
text_cqt:SetFontSize(18)
text_cqt:SetFontColor((255/255), (194/255), (63/255), 1)
--text_cqt:SetFont(fontSource, font)

local text_status = UI.CreateFrame("Text", "CQTC", context)
text_status:SetPoint("CENTER", window, "CENTER", 0, -26)
text_status:SetText("")
text_status:SetLayer(6)
text_status:SetFontSize(14)
--text_status:SetFont(fontSource, font)


local text_dom_percent = UI.CreateFrame("Text", "CQTC", context)
text_dom_percent:SetPoint("CENTER", window, "CENTER", -55, 22)
text_dom_percent:SetText("")
text_dom_percent:SetLayer(6)
text_dom_percent:SetFontSize(percent_size)
--text_dom_percent:SetFont(fontSource, font)

local text_nf_percent = UI.CreateFrame("Text", "CQTC", context)
text_nf_percent:SetPoint("CENTER", window, "CENTER", 0, 22)
text_nf_percent:SetText("")
text_nf_percent:SetLayer(6)
text_nf_percent:SetFontSize(percent_size)
text_nf_percent:SetFontColor(0, 1, 0, 1)
--text_nf_percent:SetFont(fontSource, font)

local text_oath_percent = UI.CreateFrame("Text", "CQTC", context)
text_oath_percent:SetPoint("CENTER", window, "CENTER", 55, 22)
text_oath_percent:SetText("")
text_oath_percent:SetLayer(6)
text_oath_percent:SetFontSize(percent_size)
--text_oath_percent:SetFont(fontSource, font)

local function AttachDragFrame(parent, name, layer)

	if not name then name = "" end
	if not layer then layer = 0 end
	
	local DragFrame = UI.CreateFrame("Frame", name.."_DragFrame", parent)
	DragFrame:SetPoint("TOPLEFT", parent, "TOPLEFT")
	DragFrame:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT")
	DragFrame.parent = parent
	DragFrame.MouseDown = false
	DragFrame:SetLayer(layer)
	
	function DragFrame.Event:LeftDown()
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.MyStartX = self.parent:GetLeft()
		self.MyStartY = self.parent:GetTop()
		self.StartX = mouseData.x - self.MyStartX
		self.StartY = mouseData.y - self.MyStartY
		tempX = self.parent:GetLeft()
		tempY = self.parent:GetTop()
		tempW = self.parent:GetWidth()
		tempH =	self.parent:GetHeight()
		self.parent:ClearAll()
		self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", tempX, tempY)
		self.parent:SetWidth(tempW)
		self.parent:SetHeight(tempH)
	end
	function DragFrame.Event:MouseMove(mouseX, mouseY)
		if self.MouseDown then
			self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (mouseX - self.StartX), (mouseY - self.StartY))
		end
	end
	function DragFrame.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
	end
	
	return DragFrame
end

local dragframe = AttachDragFrame(window, "Dragframe", 10)
dragframe:SetVisible(true)

function buildTextBorder(text)
	text.border_1 = UI.CreateFrame("Text", "CQTC", context)
	text.border_1:SetPoint("CENTER", text, "CENTER", 1, 1)
	text.border_1:SetText(text:GetText())
	text.border_1:SetLayer(text:GetLayer()-1)
	text.border_1:SetFontSize(text:GetFontSize())
	text.border_1:SetFontColor(0, 0, 0, 0.5)
	text.border_1:SetFont(text:GetFont())
	
	text.border_2 = UI.CreateFrame("Text", "CQTC", context)
	text.border_2:SetPoint("CENTER", text, "CENTER", -1, 1)
	text.border_2:SetText(text:GetText())
	text.border_2:SetLayer(text:GetLayer()-1)
	text.border_2:SetFontSize(text:GetFontSize())
	text.border_2:SetFontColor(0, 0, 0, 0.5)
	text.border_2:SetFont(text:GetFont())
	
	text.border_3 = UI.CreateFrame("Text", "CQTC", context)
	text.border_3:SetPoint("CENTER", text, "CENTER", -1, -1)
	text.border_3:SetText(text:GetText())
	text.border_3:SetLayer(text:GetLayer()-1)
	text.border_3:SetFontSize(text:GetFontSize())
	text.border_3:SetFontColor(0, 0, 0, 0.5)
	text.border_3:SetFont(text:GetFont())
	
	text.border_4 = UI.CreateFrame("Text", "CQTC", context)
	text.border_4:SetPoint("CENTER", text, "CENTER", 1, -1)
	text.border_4:SetText(text:GetText())
	text.border_4:SetLayer(text:GetLayer()-1)
	text.border_4:SetFontSize(text:GetFontSize())
	text.border_4:SetFontColor(0, 0, 0, 0.5)
	text.border_4:SetFont(text:GetFont())
end

function setTextWithBorder(text, message)
	if (tostring(message) ~= text:GetText()) then
		text:SetText(tostring(message))
		text.border_1:SetText(tostring(message))
		text.border_2:SetText(tostring(message))
		text.border_3:SetText(tostring(message))
		text.border_4:SetText(tostring(message))
	end
end

function setTextAlphaWithBorder(text, alpha)
	text:SetAlpha(alpha)
	text.border_1:SetAlpha(alpha)
	text.border_2:SetAlpha(alpha)
	text.border_3:SetAlpha(alpha)
	text.border_4:SetAlpha(alpha)
end

function setTextVisibleWithBorder(text, visible)
	text:SetVisible(visible)
	text.border_1:SetVisible(visible)
	text.border_2:SetVisible(visible)
	text.border_3:SetVisible(visible)
	text.border_4:SetVisible(visible)
end

buildTextBorder(text_cqt)
buildTextBorder(text_status)
buildTextBorder(text_oath_percent)
buildTextBorder(text_nf_percent)
buildTextBorder(text_dom_percent)

function updateEnd()
	
	if (Inspect.Time.Real() >= update_animation+0.1 and animation_red == true and animation_fadeIn == false and animation_fadeOut == false) then
		local animationStep = 0.05
		
		if (window_shadow_red.animationDirection == "+") then
			local alpha = window_shadow_red:GetAlpha() + animationStep
			if (alpha < 1) then
				window_shadow_red:SetAlpha(alpha)
			else
				window_shadow_red:SetAlpha(1)
				window_shadow_red.animationDirection = "-"
			end
		else
			local alpha = window_shadow_red:GetAlpha() - animationStep
			if (alpha > 0) then
				window_shadow_red:SetAlpha(alpha)
			else
				window_shadow_red:SetAlpha(0)
				window_shadow_red.animationDirection = "+"
			end
		end
	elseif (animation_red == false) then
		window_shadow_red.animationDirection = "+"
		window_shadow_red:SetAlpha(0)
	end
	
	-- FadeIn
	if (Inspect.Time.Real() >= update_animation+0.1 and animation_fadeIn == true) then
		local animationStep = 0.05
		local alpha = window:GetAlpha() + animationStep
		if (alpha < 1) then
			window:SetVisible(true)
			window_shadow_red:SetVisible(true)
			icon_dom:SetVisible(true)
			icon_nf:SetVisible(true)
			icon_oath:SetVisible(true)
			setTextVisibleWithBorder(text_cqt, true)
			setTextVisibleWithBorder(text_status, true)
			setTextVisibleWithBorder(text_dom_percent, true)
			setTextVisibleWithBorder(text_nf_percent, true)
			setTextVisibleWithBorder(text_oath_percent, true)
			dragframe:SetVisible(true)
			window:SetAlpha(alpha)
			icon_dom:SetAlpha(alpha)
			icon_nf:SetAlpha(alpha)
			icon_oath:SetAlpha(alpha)
			setTextAlphaWithBorder(text_cqt, alpha)
			setTextAlphaWithBorder(text_status, alpha)
			setTextAlphaWithBorder(text_dom_percent, alpha)
			setTextAlphaWithBorder(text_nf_percent, alpha)
			setTextAlphaWithBorder(text_oath_percent, alpha)
		else
			window:SetAlpha(1)
			window_shadow_red:SetVisible(true)
			icon_dom:SetAlpha(1)
			icon_nf:SetAlpha(1)
			icon_oath:SetAlpha(1)
			setTextAlphaWithBorder(text_cqt, 1)
			setTextAlphaWithBorder(text_status, 1)
			setTextAlphaWithBorder(text_dom_percent, 1)
			setTextAlphaWithBorder(text_nf_percent, 1)
			setTextAlphaWithBorder(text_oath_percent, 1)
			window:SetVisible(true)
			icon_dom:SetVisible(true)
			icon_nf:SetVisible(true)
			icon_oath:SetVisible(true)
			setTextVisibleWithBorder(text_cqt, true)
			setTextVisibleWithBorder(text_status, true)
			setTextVisibleWithBorder(text_dom_percent, true)
			setTextVisibleWithBorder(text_nf_percent, true)
			setTextVisibleWithBorder(text_oath_percent, true)
			dragframe:SetVisible(true)
			animation_fadeIn = false
			window_visible = 1
		end
	end
	
	-- FadeOut
	if (Inspect.Time.Real() >= update_animation+0.1 and animation_fadeOut == true) then
		local animationStep = 0.05
		local alpha = window:GetAlpha() - animationStep
		if (alpha > 0) then
			window:SetAlpha(alpha)
			icon_dom:SetAlpha(alpha)
			icon_nf:SetAlpha(alpha)
			icon_oath:SetAlpha(alpha)
			setTextAlphaWithBorder(text_cqt, alpha)
			setTextAlphaWithBorder(text_status, alpha)
			setTextAlphaWithBorder(text_dom_percent, alpha)
			setTextAlphaWithBorder(text_nf_percent, alpha)
			setTextAlphaWithBorder(text_oath_percent, alpha)
		else
			window:SetAlpha(0)
			icon_dom:SetAlpha(0)
			icon_nf:SetAlpha(0)
			icon_oath:SetAlpha(0)
			setTextAlphaWithBorder(text_cqt, 0)
			setTextAlphaWithBorder(text_status, 0)
			setTextAlphaWithBorder(text_dom_percent, 0)
			setTextAlphaWithBorder(text_nf_percent, 0)
			setTextAlphaWithBorder(text_oath_percent, 0)
			window:SetVisible(false)
			window_shadow_red:SetVisible(false)
			icon_dom:SetVisible(false)
			icon_nf:SetVisible(false)
			icon_oath:SetVisible(false)
			setTextVisibleWithBorder(text_cqt, false)
			setTextVisibleWithBorder(text_status, false)
			setTextVisibleWithBorder(text_dom_percent, false)
			setTextVisibleWithBorder(text_nf_percent, false)
			setTextVisibleWithBorder(text_oath_percent, false)
			dragframe:SetVisible(false)
			animation_fadeOut = false
			window_visible = 0
		end
	end
	
	if (Inspect.Time.Real() >= blockerConquest+20) then
		Command.Message.Accept(nil, addon_messageId)
	else
		Command.Message.Reject(nil, addon_messageId)
	end

	if (Inspect.Time.Real() >= updater+1) then

		updater = Inspect.Time.Real()
		
		setTextWithBorder(text_cqt, "ConquestTracker")
		
		-- Anzeige aktualisieren
		if (timer >= (Inspect.Time.Server()-60)) then
			if (kills ~= 9999 and dom < 65 and nf < 65 and oath < 65) then
				
				setTextWithBorder(text_status, ("Kills left: " .. kills))
				setTextWithBorder(text_dom_percent, dom)
				setTextWithBorder(text_nf_percent, nf)
				setTextWithBorder(text_oath_percent, oath)
				
				animation_red = false
				precent_color()
				
				if (window_visible == 0 and animation_fadeIn == false and addon_state == "auto") then
					animation_fadeIn = true
				end
				
			elseif (kills == 9999 and dom == 9999 and nf == 9999 and oath == 9999) then
				
				timer_conquestEnd = 0
				
				setTextWithBorder(text_status, "Conquest is over")
				setTextWithBorder(text_dom_percent, "")
				setTextWithBorder(text_nf_percent, "")
				setTextWithBorder(text_oath_percent, "")
				
				animation_red = false
				precent_color()
				
				if (window_visible == 1 and animation_fadeOut == false and addon_state == "auto") then
					animation_fadeOut = true
				end
				
			elseif ((kills == 9999 or (dom >= 65 or nf >= 65 or oath >= 65)) and timer_conquestEnd ~= 0) then
				
				local timer_min = 0
				local timer_sec = 0 
				
				local timer_diff = (300 - (Inspect.Time.Server() - timer_conquestEnd)) - 1
				
				if (timer_diff <= 300 and timer_diff ~= 0) then
					
					timer_min = math.floor(timer_diff / 60)
					timer_sec = math.floor(timer_diff % 60)
				
				end
				
				if (timer_min < 0) then
					timer_min = 0
					timer_sec = 0
				end
				
				if (timer_sec < 10) then
					timer_sec = "0" .. tostring(timer_sec)
				end
	
				setTextWithBorder(text_status, "Time left: " .. tostring(timer_min) .. ":" .. tostring(timer_sec))
				setTextWithBorder(text_dom_percent, dom)
				setTextWithBorder(text_nf_percent, nf)
				setTextWithBorder(text_oath_percent, oath)
				
				animation_red = true
				precent_color()
				
				if (window_visible == 0 and animation_fadeIn == false and addon_state == "auto") then
					animation_fadeIn = true
				end
			
			elseif (kills == 9999 or (dom >= 65 or nf >= 65 or oath >= 65)) then
				setTextWithBorder(text_status, "Time left: n/a")
				setTextWithBorder(text_dom_percent, dom)
				setTextWithBorder(text_nf_percent, nf)
				setTextWithBorder(text_oath_percent, oath)
				
				animation_red = true
				precent_color()
				
				if (window_visible == 0 and animation_fadeIn == false and addon_state == "auto") then
					animation_fadeIn = true
				end
			end
		else
			setTextWithBorder(text_status, "No information found")
			setTextWithBorder(text_dom_percent, "")
			setTextWithBorder(text_nf_percent, "")
			setTextWithBorder(text_oath_percent, "")
			
			timer_conquestEnd = 0
			
			animation_red = false
			precent_color()
			
			if (window_visible == 1 and animation_fadeOut == false and addon_state == "auto") then
				animation_fadeOut = true
			end
		end
	end
end

function precent_color()
	
	-- Dom
	if (dom > nf and dom > oath) then
		text_dom_percent:SetFontColor(0, 1, 0, 1)
	elseif (dom < nf or dom < oath) then
		text_dom_percent:SetFontColor(1, 0, 0, 1)
	else
		text_dom_percent:SetFontColor(1, 1, 0, 1)
	end
	
	-- Nf
	if (nf > dom and nf > oath) then
		text_nf_percent:SetFontColor(0, 1, 0, 1)
	elseif (nf < dom or nf < oath) then
		text_nf_percent:SetFontColor(1, 0, 0, 1)
	else
		text_nf_percent:SetFontColor(1, 1, 0, 1)
	end
	
	-- Oath
	if (oath > nf and oath > dom) then
		text_oath_percent:SetFontColor(0, 1, 0, 1)
	elseif (oath < nf or oath < dom) then
		text_oath_percent:SetFontColor(1, 0, 0, 1)
	else
		text_oath_percent:SetFontColor(1, 1, 0, 1)
	end
	
end

function questChanged(elements)

	local conquest = {}
	for k,v in pairs(elements) do
		if (k=="q5FAF0EB42AC65A22") then
			conquest = Inspect.Quest.Detail(k)
		end
	end
	
	if (conquest and conquest.objective and conquest.watch and conquest.watch == true) then
			
		blockerConquest = Inspect.Time.Real()
		
		local i = 1
		local stuff = {}
			
		for k,v in pairs(conquest.objective) do
			stuff[i] = v.countDone
			i = i + 1
		end
			
		-- Eroberung luft ganz normal!
		if (i==6) then
		
			-- Berechne verbleibende Siege
			kills = 2500 - stuff[4]
			
			-- Prozente der Fraktionen ausrechnen
			dom = math.floor(100/18*stuff[1])
			nf = math.floor(100/18*stuff[2])
			oath = math.floor(100/18*stuff[3])
			
			-- Zeitstempel setzen
			timer = Inspect.Time.Server()
				
			-- Nachricht verbreiten!
			local message = dom .. ";" .. nf .. ";" .. oath .. ";" .. kills .. ";" .. timer .. ";" .. timer_conquestEnd .. ";" .. "1"
			Command.Message.Broadcast("guild", nil, addon_messageId, message);
			if (realmpool == "EU") then
				Command.Message.Broadcast("channel", "ConquestTracker@Brutwacht", addon_messageId, message)
			elseif (realmpool == "US") then
				Command.Message.Broadcast("channel", "ConquestTracker@Deepwood", addon_messageId, message)
			end
			
		-- Eroberung, letzte 5 Minuten!
		elseif (i==5) then
				
			-- Kills auf 9999 setzen, bedeutet die letzten 5 Minuten laufen!
			kills = 9999
				
			-- Prozente der Fraktionen ausrechnen
			dom = math.floor(100/18*stuff[1])
			nf = math.floor(100/18*stuff[2])
			oath = math.floor(100/18*stuff[3])
				
			-- Zeitstempel setzen
			timer = Inspect.Time.Server()
				
			-- Nachricht verbreiten!
			local message = dom .. ";" .. nf .. ";" .. oath .. ";" .. kills .. ";" .. timer .. ";" .. timer_conquestEnd .. ";" .. "1"
			Command.Message.Broadcast("guild", nil, addon_messageId, message)
			
			if (realmpool == "EU") then
				Command.Message.Broadcast("channel", "ConquestTracker@Brutwacht", addon_messageId, message)
			elseif (realmpool == "US") then
				Command.Message.Broadcast("channel", "ConquestTracker@Deepwood", addon_messageId, message)
			end
				
		-- Die letzten 10 Minuten laufen!
		elseif (i==2 and conquest.watch == true) then
			-- Kills auf 9999 setzen, bedeutet die letzten 5 Minuten laufen!
			kills = 9999
				
			-- Werte auf 9999 setzen!
			dom = 9999
			nf = 9999
			oath = 9999
				
			-- Zeitstempel setzen
			timer = Inspect.Time.Server()
				
			-- Nachricht verbreiten!
			local message = dom .. ";" .. nf .. ";" .. oath .. ";" .. kills .. ";" .. timer .. ";" .. timer_conquestEnd .. ";" .. "1"
			Command.Message.Broadcast("guild", nil, addon_messageId, message)
			
			if (realmpool == "EU") then
				Command.Message.Broadcast("channel", "ConquestTracker@Brutwacht", addon_messageId, message)
			elseif (realmpool == "US") then
				Command.Message.Broadcast("channel", "ConquestTracker@Deepwood", addon_messageId, message)
			end
		end
	end
end

function messages(from, messagetype, channel, id, data)
	if (channel == nil and id==addon_messageId and ((Inspect.Time.Real() >= (waiter+5)) or (messagetype == "guild"))) then
		--if (id==addon_messageId) then
			
			--dump(data)
			
			local stuff = {}
			local i = 1
			for token in string.gmatch(data, "[^%;]+") do
				stuff[i] = token
				--print(stuff[i])
				i = i + 1
			end
			
			local dom_temp = tonumber(stuff[1]) or nil
			local nf_temp = tonumber(stuff[2]) or nil
			local oath_temp = tonumber(stuff[3]) or nil
			local kills_temp = tonumber(stuff[4]) or nil
			local timer_temp = tonumber(stuff[5]) or nil
			local timer_conquestEnd_temp = tonumber(stuff[6]) or nil
			local newDataFlag = tonumber(stuff[7]) or nil
			
			if (((addon_global == true and (Inspect.Time.Real() >= blocker + 10))) or (messagetype == "guild" and newDataFlag == 1)) then
				if ((dom_temp ~= nil and ((dom_temp >= 0 and dom_temp <= 100) or dom_temp == 9999)) and (nf_temp ~= nil and ((nf_temp >= 0 and nf_temp <= 100) or nf_temp == 9999)) and (oath_temp ~= nil and ((oath_temp >= 0 and oath_temp <= 100) or oath_temp == 9999)) and (kills_temp ~= nil and ((kills_temp >= 0 and kills_temp <= 2500) or kills_temp == 9999)) and (timer_temp ~= nil and (timer_temp <= Inspect.Time.Server()+15 and timer_temp >= (Inspect.Time.Server()-15))) and (timer_conquestEnd_temp ~= nil) and (((dom_temp + nf_temp + oath_temp) <= 100) or (dom_temp == 9999 and nf_temp == 9999 and oath_temp == 9999))) then
					--dump(from, messagetype, channel, id, data)
					--print("test")
					-- Werte sind ok und werden bernommen
					dom = dom_temp
					nf = nf_temp
					oath = oath_temp
					kills = kills_temp
					timer = timer_temp
					if (timer_conquestEnd_temp ~= nil and timer_conquestEnd_temp ~= 0 and timer_conquestEnd == 0 and (timer_conquestEnd_temp <= Inspect.Time.Server() and timer_conquestEnd_temp >= (Inspect.Time.Server()-300))) then
						timer_conquestEnd = timer_conquestEnd_temp
					elseif (timer_conquestEnd_temp ~= nil and timer_conquestEnd_temp ~= 0 and messagetype == "guild" and newDataFlag ~= nil and newDataFlag == 1) then
						timer_conquestEnd = timer_conquestEnd_temp
					end
					
					-- Informationen weitergeben
					if (Inspect.Time.Real() >= (waiter+5)) then
						local message = dom .. ";" .. nf .. ";" .. oath .. ";" .. kills .. ";" .. timer .. ";" .. timer_conquestEnd .. ";" .. "0"
						if (Inspect.Time.Real() >= (blockerConquest + 20)) then
							if (messagetype ~= "guild") then Command.Message.Broadcast("guild", nil, addon_messageId, message) end
							if (messagetype ~= "yell") then Command.Message.Broadcast("yell", nil, addon_messageId, message) end
							if (messagetype ~= "party" and messagetype ~= "raid") then Command.Message.Broadcast("party", nil, addon_messageId, message) end
							if (messagetype ~= "raid" and messagetype ~= "party") then Command.Message.Broadcast("raid", nil, addon_messageId, message) end
							if (messagetype ~= "channel") then	
								if (realmpool == "EU") then
									Command.Message.Broadcast("channel", "ConquestTracker@Brutwacht", addon_messageId, message)
								elseif (realmpool == "US") then
									Command.Message.Broadcast("channel", "ConquestTracker@Deepwood", addon_messageId, message)
								end
							end
							
							-- 5 Sekunden warten
							waiter = Inspect.Time.Real()
						end
					end
					
					-- Jemand aus der eigenen Gilde ist in Eroberung
					if (messagetype == "guild" and newDataFlag == 1) then
						blocker = Inspect.Time.Real()
					end
					
				end
			end
		--end
	end
end

function slash_cqt(parameter)
	
	if (parameter == "") then
		print("Commandlist:")
		print("/cqt on (Addon is always visible)")
		print("/cqt off (Addon is hidden)")
		print("/cqt toggle (Addon toggles between on and off)")
		print("/cqt auto (Addon is only visible when necessary)")
		print("/cqt global (Addon use all data sources)")
		print("/cqt guild (Addon use only data collected from guildmates)")
	elseif (parameter == "on") then
		print("ON: Addon is always visible!")
		addon_state = "on"
		if (window_visible == 0) then
			animation_fadeIn = true
		end
	elseif (parameter == "off") then
		print("OFF: Addon is hidden!")
		addon_state = "off"
		if (window_visible == 1) then
			animation_fadeOut = true
		end
	elseif (parameter == "toggle") then
		if (window_visible == 1) then
			print("OFF: Addon is hidden!")
			animation_fadeOut = true
			addon_state = "off"
		else
			print("ON: Addon is always visible!")
			animation_fadeIn = true
			addon_state = "on"
		end
	elseif (parameter == "auto") then
		print("AUTO: Addon is only visible when necessary!")
		addon_state = "auto"
	elseif (parameter == "global") then
		print("GLOBAL: Addon use all data sources!")
		addon_global = true
	elseif (parameter == "guild") then
		print("GUILD: Addon use only data collected from guildmates!")
		addon_global = false
	else
		print("Unknown command!")
		print("Commandlist:")
		print("/cqt on (Addon is visible)")
		print("/cqt off (Addon is hidden)")
		print("/cqt toggle (Addon toggles between on and off)")
		print("/cqt auto (Addon is only visible when necessary)")
		print("/cqt global (Addon use all data sources)")
		print("/cqt guild (Addon use only data collected from guildmates)")
	end
end

function ChatNotify(info)
	if (info.message == language[sysLanguage].conquest_message_last5minutes) then
	
		blockerConquest = Inspect.Time.Real()
		
		timer_conquestEnd = Inspect.Time.Server()
		
		local message = dom .. ";" .. nf .. ";" .. oath .. ";" .. kills .. ";" .. timer .. ";" .. tostring(timer_conquestEnd) .. ";" .. "1"
		
		Command.Message.Broadcast("guild", nil, addon_messageId, message)
		if (realmpool == "EU") then
			Command.Message.Broadcast("channel", "ConquestTracker@Brutwacht", addon_messageId, message)
		elseif (realmpool == "US") then
			Command.Message.Broadcast("channel", "ConquestTracker@Deepwood", addon_messageId, message)
		end
	end
end

local function cqt_load(addon)
	if addon == "ConquestTracker" then
		local posi_x = 350
		local posi_y = 350
		
		if position_x then
			posi_x = position_x
		end
		
		if position_y then
			posi_y = position_y
		end
		
		if addonstate then
			addon_state = addonstate
		end
		
		if addonglobal then
			addon_global = addonglobal
		end
		
		if (addon_state == "off" or addon_state == "auto") then
			window:SetAlpha(0)
			icon_dom:SetAlpha(0)
			icon_nf:SetAlpha(0)
			icon_oath:SetAlpha(0)
			setTextAlphaWithBorder(text_cqt, 0)
			setTextAlphaWithBorder(text_status, 0)
			setTextAlphaWithBorder(text_dom_percent, 0)
			setTextAlphaWithBorder(text_nf_percent, 0)
			setTextAlphaWithBorder(text_oath_percent, 0)
			window:SetVisible(false)
			window_shadow_red:SetVisible(false)
			icon_dom:SetVisible(false)
			icon_nf:SetVisible(false)
			icon_oath:SetVisible(false)
			setTextVisibleWithBorder(text_cqt, false)
			setTextVisibleWithBorder(text_status, false)
			setTextVisibleWithBorder(text_dom_percent, false)
			setTextVisibleWithBorder(text_nf_percent, false)
			setTextVisibleWithBorder(text_oath_percent, false)
			dragframe:SetVisible(false)
			window_visible = 0
		else
			window:SetAlpha(1)
			icon_dom:SetAlpha(1)
			icon_nf:SetAlpha(1)
			icon_oath:SetAlpha(1)
			setTextAlphaWithBorder(text_cqt, 1)
			setTextAlphaWithBorder(text_status, 1)
			setTextAlphaWithBorder(text_dom_percent, 1)
			setTextAlphaWithBorder(text_nf_percent, 1)
			setTextAlphaWithBorder(text_oath_percent, 1)
			window:SetVisible(true)
			window_shadow_red:SetVisible(true)
			icon_dom:SetVisible(true)
			icon_nf:SetVisible(true)
			icon_oath:SetVisible(true)
			setTextVisibleWithBorder(text_cqt, true)
			setTextVisibleWithBorder(text_status, true)
			setTextVisibleWithBorder(text_dom_percent, true)
			setTextVisibleWithBorder(text_nf_percent, true)
			setTextVisibleWithBorder(text_oath_percent, true)
			dragframe:SetVisible(true)
			window_visible = 1
		end
		
		window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", posi_x, posi_y)
	end
end

local function cqt_save(addon)
	if addon == "ConquestTracker" then
		position_x = math.floor(window:GetLeft())
		position_y = math.floor(window:GetTop())
		addonstate = addon_state
		addonglobal = addon_global
	end
end

Command.Message.Accept(nil, addon_messageId)
table.insert(Command.Slash.Register("cqt"), {slash_cqt, "ConquestTracker", "rt"})
table.insert(Event.Message.Receive, { messages, "ConquestTracker", "MessagesRe" })
table.insert(Event.System.Update.End, { updateEnd, "ConquestTracker", "update" })
table.insert(Event.Quest.Change, {questChanged, "ConquestTracker", "QuestChanged"})
table.insert(Event.Chat.Notify, {ChatNotify, "ConquestTracker", "ChatNotify"})
table.insert(Event.Addon.SavedVariables.Save.Begin, {cqt_save, "ConquestTracker", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {cqt_load, "ConquestTracker", "Load variables"})