--[[
File: Interface/RiftWindow.lua
Author: Zormus
--]]

local Interface = Library[(...).identifier].Interface
Interface.RiftWindow = setmetatable({}, Interface.Frame)
local RiftWindow = Interface.RiftWindow
RiftWindow.__index = RiftWindow

function RiftWindow:Initialize()
	self.dragBar = Interface.Create("Frame", "DragBar", self)
	self.dragBar:SetPoint("TOPLEFT", self, "TOPLEFT", 44, 12)
	self.dragBar:SetPoint("TOPRIGHT", self, "TOPRIGHT", -44, 12)
	self.dragBar:SetHeight(34)
	self.dragBar:SetDragFrame(self)
	self.dragBar:EnableDrag(true, "Left")
	self.close = Interface.Create("RiftButton", "CloseButton", self)
	self.close:SetSkin("close")
	self.close:SetPoint("TOPRIGHT", self, "TOPRIGHT", -8, 16)
	self.close:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, handle) self:GetParent():Close() end, "Close")
end

function RiftWindow:Close()
	if self.OnClose then
		self:OnClose()
	end
	self:SetVisible(false)
end
