local addon, shared = ...

local RELEASE=		99
local TESTING=		20
local WDOGYIELD=	15
local FUNCTIONRUN=	10
local STATUSUPDT=	8
local INFORMATION=	5
local DETAIL=		1

---------------------
-- Variables
---------------------

_Teleporter = {}
local TP = _Teleporter

local UIFrames = { abw = 0, abilities = {}, POPUPANCHOR = "CENTER" }
TP.UI = UIFrames

local UINeeded = true
local SVLoaded = false
local coroDead = false

local playerFound = false
local tpmenuVis = false
local itemidcnt = 0

local tprebuild = false

local TPMODE_POPUP = 1
local TPMODE_CLICK = 2

local frW = 0

local tpabilities = {
	["A3C5AEC64D3793518"] = { p=1, txt = "SOUL RECALL", 			type = "spell",	able = false, use = nil, icon = nil },
	["A5A5C6D30430A9E3E"] = { p=2, txt = "GLOAMWOOD", 				type = "spell", able = false, use = nil, icon = nil, zoneid = "z0000001B2BB9E10E" },
	["A677B0D96691D0433"] = { p=3, txt = "STONEFIELD", 				type = "spell", able = false, use = nil, icon = nil, zoneid = "z585230E5F68EA919" },
	["A768D08F826CDC3DB"] = { p=4, txt = "SCARWOOD REACH", 			type = "spell", able = false, use = nil, icon = nil, zoneid = "z000000142C649218" },
	["A6B16924B96299E96"] = { p=5, txt = "DROUGHTLANDS", 			type = "spell", able = false, use = nil, icon = nil, zoneid = "z1416248E485F6684" },
	["A313102E6A9A460E8"] = { p=6, txt = "MOONSHADE HIGHLANDS", 	type = "spell", able = false, use = nil, icon = nil, zoneid = "z0000001804F56C61" },
	["A657AA5389319EF0F"] = { p=7, txt = "EMBER ISLE", 				type = "spell", able = false, use = nil, icon = nil, zoneid = "z76C88A5A51A38D90" },
	["TP_CHANCELOFLABORS"]= { p=8, txt = "CHANCEL OF LABORS", 		type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\totem_air_mundane_a.dds", item = "I731C1B4F46334030,293CCC1E8957C704,,,,,,", id = 0 },
	["TP_WYRMBANESPIRE"]  = { p=9, txt = "WYRMBANE SPIRE", 			type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\totem_air_mundane_a.dds", item = "I139E7010C5722EA5,DF73A68C936CC83F,,,,,,", id = 0 },
	["TP_ZAREPHSRETURN"] = { p=10, txt = "ZAREPH'S RETURN", 		type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\totem_air_mundane_a.dds", item = "I1C6AA9C8821E8F6D,22FC684EB50BD66F,,,,,,", id = 0 },
	["TP_HQUNSEEN"] 	 = { p=11, txt = "HQ of The Unseen", 		type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\totem6.dds", item = "I2E86B87446CF32BF,4A4CA14475FECC39,,,,,,", id = 0 },
	["TP_TEMPEST_BAY"]	={p=12, txt ="TEMPEST BAY",					type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\totem_air_mundane.dds", item = "I4D97EE3EB79275CD,7EB547DFB8F5C0A7,,,,,,", id = 0 },
	["TP_BREVANIC_PORTAL"]={p=13, txt ="Brevanic Portal Generator",	type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\fatestone_05_neutral_a.dds", item = "IFAFB17B78F862295,2372E487E1EDD0FA,,,,,,", id = 0 },
	["A5FAA42C94B361BD6"] = {p=14, txt="Summon Group: Earth",		type = "spell", able=false, use = nil, icon=nil},
	["A6FA8AEF1A6A24562"] = {p=15, txt="Summon Group: Air",			type = "spell", able=false, use = nil, icon=nil},
	["A598E67739FF9FE12"] = {p=16, txt="Summon Group: Fire",		type = "spell", able=false, use = nil, icon=nil},
	["A6005565590545A0D"] = {p=17, txt="Summon Group: Water",		type = "spell", able=false, use = nil, icon=nil},
	["A7ADD26548CAD37A8"] = {p=18, txt="Summon Group: Life",		type = "spell", able=false, use = nil, icon=nil},
	["A5DF0C9E7AA17967F"] = {p=19, txt="Summon Group: Death",		type = "spell", able=false, use = nil, icon=nil},
	["A5F77DAA65FAED9E3"] = {p=20, txt="Guild Rally Banner",		type = "spell", able=false, use = nil, icon=nil},
	["TP_RALLYBANNER"] = {p=21, txt="RALLY BANNER",					type = "item",	able = false, use = nil, icon = "Data/\\UI\\item_icons\\scroll7.dds", item = "I1F832DB376787EBF,D912113BAA7304B3,,,,,,", id = 0 },
}

local _tpitems = {
	["I731C1B4F46334030,293CCC1E8957C704,,,,,,"] = "TP_CHANCELOFLABORS",
	["I139E7010C5722EA5,DF73A68C936CC83F,,,,,,"] = "TP_WYRMBANESPIRE", 
	["I1C6AA9C8821E8F6D,22FC684EB50BD66F,,,,,,"] = "TP_ZAREPHSRETURN",
	["I2E86B87446CF32BF,4A4CA14475FECC39,,,,,,"] = "TP_HQUNSEEN",
	["IFAFB17B78F862295,2372E487E1EDD0FA,,,,,,"] = "TP_BREVANIC_PORTAL",
	["I4D97EE3EB79275CD,7EB547DFB8F5C0A7,,,,,,"] = "TP_TEMPEST_BAY",
	["I1F832DB376787EBF,D912113BAA7304B3,,,,,,"] = "TP_RALLYBANNER",
}	

local tpframes = {}

for k,v in pairs(tpabilities) do
	tpframes[v.p] = k
end

local default_settings = {
	mmx = -1, mmy = -1, itemid = {}, align = "C", mode = TPMODE_POPUP, locked = true
}

---------------------
-- Functions
---------------------

local debuglevel = RELEASE

local function Debug(s,l)
	if (l or INFORMATION) >= debuglevel then
		print(s)
	end
end

local _watchdogyield = {}
local yieldcnt = 0
local function WATCHDOGWAIT(x)
	local rmx = Inspect.System.Watchdog()
	while rmx < 0.03 do
		yieldcnt = yieldcnt+1
		Debug("#"..yieldcnt..":rmx: "..rmx.." ["..x.."]",WDOGYIELD)
		_watchdogyield[yieldcnt] = { tx = os.date("%Y%m%d-%H:%M:%S"), m = x, tr = rmx }
		coroutine.yield()
		rmx = Inspect.System.Watchdog()
	end
end

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}				
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

function TP.ShowPopup()
	if (Inspect.System.Secure() == true) or (Teleporter_Settings.locked == false) then
		return
	end
	
	if MINIMAPDOCKER then
		MINIMAPDOCKER.AUTOHIDE_DOCKED = false
	end
	
	for k,v in pairs(tpabilities) do
		if v.able == true then
			if v.type == "spell" then
				local d = Inspect.Ability.New.Detail(k)
				if d ~= nil then
					if (d.currentCooldownRemaining or 0) > 0 then
						UIFrames.abilities[v.p].frame:SetBackgroundColor(1,0,0,0.5)
						UIFrames.abilities[v.p].cd = true
					else
						UIFrames.abilities[v.p].frame:SetBackgroundColor(0,0,0,0.5)
						UIFrames.abilities[v.p].cd = false
					end
				end
			else
				local d = Inspect.Item.Detail(v.item)
				if d ~= nil then
					if (d.cooldownRemaining or 0) > 0 then
						UIFrames.abilities[v.p].frame:SetBackgroundColor(1,0,0,0.5)
						UIFrames.abilities[v.p].cd = true
					else
						UIFrames.abilities[v.p].frame:SetBackgroundColor(0,0,0,0.5)
						UIFrames.abilities[v.p].cd = false
					end
				end
			end
		end
	end

	tpmenuVis = true
	UIFrames.frame:SetVisible(true)
end

function TP.AttachPopup()
	local h_loc
	local v_loc
	local anchor
	
	if UIFrames.mm_button:GetLeft() >= (UIParent:GetWidth()/2) then
		h_loc = "RIGHT"
	else
		h_loc = "LEFT"
	end
	
	if UIFrames.mm_button:GetTop() >= (UIParent:GetHeight()/2) then
		v_loc = "BOTTOM"
	else
		v_loc = "TOP"
	end
	
	anchor = string.format("%s%s", v_loc, h_loc)
	
	if anchor ~= UIFrames.POPUPANCHOR then
		UIFrames.frame:ClearPoint(UIFrames.POPUPANCHOR)
		UIFrames.POPUPANCHOR = anchor
		UIFrames.frame:SetPoint(anchor, UIFrames.mm_button, "CENTER", 0,0)
	end
end

function TP.CreateTPEntry(t,u,i)
	WATCHDOGWAIT("CreateTPEntry:1")
	local f = {}
	f.cd = false
	f.frame = UI.CreateFrame("Frame", "f.frame", UIFrames.frame)
	f.frame:SetSecureMode("restricted")
	f.frame:SetVisible(false)
	f.frame:SetHeight(32)
	f.frame:SetLayer(1)
	f.frame:SetBackgroundColor(0,0,0,0.5)
	f.frame:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
		f.frame:SetBackgroundColor(0,1,0,0.5)
	end, "Event.UI.Input.Mouse.Cursor.In")
	f.frame:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
		if f.cd then
			f.frame:SetBackgroundColor(1,0,0,0.5)
		else
			f.frame:SetBackgroundColor(0,0,0,0.5)
		end
	end, "Event.UI.Input.Mouse.Cursor.Out")
	if u ~= nil then
		f.frame:EventMacroSet(Event.UI.Input.Mouse.Left.Click, u)
	end
	f.MACRO = u
	f.icon = UI.CreateFrame("Texture", "f.icon", f.frame)
	f.icon:SetHeight(32)
	f.icon:SetWidth(32)
	if i == nil then
		i = "Unknown"
	end
	f.icon:SetTexture("Rift", i)
	f.icon:SetPoint("TOPLEFT", f.frame, "TOPLEFT", 0,0)
	f.icon:SetLayer(2)
	f.text = UI.CreateFrame("Text", "f.text", f.frame)
	f.text:SetFontSize(16)
	f.text:SetText(t)
	UIFrames.abw = math.max(UIFrames.abw, f.text:GetWidth())
--	f.frame:SetWidth(64+frW)
	f.text:SetLayer(3)
	f.cdt = UI.CreateFrame("Text", "f.cd", f.frame)
	f.cdt:SetPoint("TOPRIGHT", f.icon, "TOPLEFT", 0,0)
	f.cdt:SetFontSize(16)
	f.cdt:SetLayer(4)
	f.cdt:SetText("")
	f.cdt:SetFontColor(1,0,0)
	--f.cd:SetVisible(false)
	return f
end

function TP.closePopup()
	if tpmenuVis then
		tpmenuVis = false
		UIFrames.frame:SetVisible(false)
	end
end

function TP.CreateUI()
	TP.context = UI.CreateContext(addon.identifier)
	TP.context:SetSecureMode("restricted")
	
	UIFrames.mm_button = UI.CreateFrame("Texture", "UIFrames.mm_button", TP.context)
	UIFrames.mm_button:SetVisible(false)
	UIFrames.mm_button:SetHeight(36)
	UIFrames.mm_button:SetWidth(36)
	UIFrames.mm_button:SetLayer(2)

	if MINIMAPDOCKER then
		MINIMAPDOCKER.Register(addon.identifier, UIFrames.mm_button, TP.closePopup)
	else
		UIFrames.mm_button:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
			self.MouseDown = true
			if Teleporter_Settings.locked == false then
				local mouseData = Inspect.Mouse()
				self.sx = mouseData.x - UIFrames.mm_button:GetLeft()
				self.sy = mouseData.y - UIFrames.mm_button:GetTop()
			end
		end, "Event.UI.Input.Mouse.Left.Down")
		
		UIFrames.mm_button:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
			if self.MouseDown and (Teleporter_Settings.locked == false) then
				local nx, ny
				local mouseData = Inspect.Mouse()
				nx = mouseData.x - self.sx
				ny = mouseData.y - self.sy
				UIFrames.mm_button:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
				TP.AttachPopup()
			end
		end, "Event.UI.Input.Mouse.Cursor.Move")
		
		UIFrames.mm_button:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			self.MouseDown = false
			Teleporter_Settings.mmx = UIFrames.mm_button:GetLeft()
			Teleporter_Settings.mmy = UIFrames.mm_button:GetTop()
		end, "Event.UI.Input.Mouse.Left.Up")
	end
	
	UIFrames.mm_button:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
		if self.MouseDown then
			Teleporter_Settings.locked = not Teleporter_Settings.locked
			if Teleporter_Settings.locked then
				UIFrames.mm_button:SetTexture(addon.identifier, "textures/mm_button.png")
				if Teleporter_Settings.mode == TPMODE_POPUP then
					TP.ShowPopup()
				end
			else
				local mouseData = Inspect.Mouse()
				self.sx = mouseData.x - UIFrames.mm_button:GetLeft()
				self.sy = mouseData.y - UIFrames.mm_button:GetTop()			
				UIFrames.mm_button:SetTexture(addon.identifier, "textures/mm_button_bw.png")
				if Inspect.System.Secure() == false then
					tpmenuVis = false
					UIFrames.frame:SetVisible(false)
				end				
			end
		elseif Teleporter_Settings.mode == TPMODE_CLICK then
			TP.ShowPopup()
		end
	end, "Event.UI.Input.Mouse.Right.Click")
	
	UIFrames.mm_button:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
		if Teleporter_Settings.mode == TPMODE_POPUP then
			TP.ShowPopup()
		end
	end, "Event.UI.Input.Mouse.Cursor.In")
	
	WATCHDOGWAIT("CreateUI:1")
	
	UIFrames.frame = UI.CreateFrame("Frame", "UIFrames.frame", TP.context)
	UIFrames.frame:SetSecureMode("restricted")
	UIFrames.frame:SetVisible(false)
	UIFrames.header= UI.CreateFrame("Text", "UIFrames.header", UIFrames.frame)
	UIFrames.header:SetFontSize(16)
	UIFrames.header:SetText("Teleport to ...")
	UIFrames.header:SetPoint("TOPLEFT", UIFrames.frame, "TOPLEFT", 0,0)
	UIFrames.header:SetFontColor(1,1,1)
	UIFrames.header:SetBackgroundColor(0,0,1)

	for k,v in pairs(shared.lang) do
		tpabilities[k].txt = shared.lang[k]
	end
	
	for k,v in pairs(tpabilities) do
		if v.type == "spell" then
			if v.zoneid ~= nil then
				local d = Inspect.Zone.Detail(v.zoneid)
				tpabilities[k].txt = d.name
			else
				local d = Inspect.Ability.New.Detail(k)
				if d then
					tpabilities[k].txt = d.name
				end
			end
		end
		UIFrames.abilities[v.p] = TP.CreateTPEntry(tpabilities[k].txt, v.use, v.icon)
	end
	
	for k,v in pairs(UIFrames.abilities) do
		v.frame:SetWidth(UIFrames.abw+64)
	end
	
	WATCHDOGWAIT("CreateUI:2")
	
	UIFrames.frame:SetWidth(UIFrames.abw+64)
	UIFrames.header:SetWidth(UIFrames.abw+64)
end

function TP.setpopupOrder()
	if Inspect.System.Secure() == false and UINeeded == false then
		local _srt = {}
		for k,v in pairs(tpabilities) do
			if v.able == true then
				table.insert(_srt, v.p)
			end
		end
		
		table.sort(_srt)
		
		local prev = UIFrames.header

		for k,v in pairs(_srt) do
			UIFrames.abilities[v].frame:SetPoint("TOPLEFT", prev, "BOTTOMLEFT", 0,0)
			UIFrames.abilities[v].frame:SetVisible(true)
			if UIFrames.abilities[v].MACRO == nil and tpabilities[tpframes[v]].use ~= nil then
				UIFrames.abilities[v].frame:EventMacroSet(Event.UI.Input.Mouse.Left.Click, tpabilities[tpframes[v]].use)
				UIFrames.abilities[v].icon:SetTexture("Rift", tpabilities[tpframes[v]].icon)
				UIFrames.abilities[v].MACRO = tpabilities[tpframes[v]].use
			end
			prev = UIFrames.abilities[v].frame
		end
		
		UIFrames.frame:SetHeight(16 + (#_srt * 32))
		tprebuild = false
	else
		tprebuild = true
	end
end

function TP.AlignText(p)
	for k, v in pairs(UIFrames.abilities) do
		v.text:ClearPoint("CENTERLEFT")
		v.text:ClearPoint("CENTER")
		v.text:ClearPoint("CENTERRIGHT")
		if p == "L" then
			v.text:SetPoint("CENTERLEFT", v.icon, "CENTERRIGHT", 0,0)
		elseif p == "R" then
			v.text:SetPoint("CENTERRIGHT", v.frame, "CENTERRIGHT", 0,0)
		else
			v.text:SetPoint("CENTER", v.frame, "CENTER", 0,0)
		end
	end
end

function TP.SVLoaded()
	if Teleporter_Settings == nil then
		Teleporter_Settings = {}
	end
	if itemidcnt > 0 then
		Teleporter_Settings.itemid = nil
	end
	
	MergeTable(Teleporter_Settings, default_settings)
	if MINIMAPDOCKER then
		Teleporter_Settings.locked = true
	else
		if Teleporter_Settings.mmx == -1 then
			UIFrames.mm_button:SetPoint("TOPCENTER", UI.Native.MapMini, "BOTTOMCENTER", 0,0)
			Teleporter_Settings.mmx = UIFrames.mm_button:GetLeft()
			Teleporter_Settings.mmy = UIFrames.mm_button:GetTop()
			UIFrames.mm_button:ClearPoint("TOPCENTER")
		end
		UIFrames.mm_button:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Teleporter_Settings.mmx, Teleporter_Settings.mmy)
	end
	
	if Teleporter_Settings.locked then
		UIFrames.mm_button:SetTexture(addon.identifier, "textures/mm_button.png")
	else
		UIFrames.mm_button:SetTexture(addon.identifier, "textures/mm_button_bw.png")
	end
	
	for k,v in pairs(Teleporter_Settings.itemid) do
		local d = Inspect.Item.Detail(v.id)
		if d ~= nil then
			local ix = tpabilities[k].p
			tpabilities[k].able = true
			tpabilities[k].id = v.id
			tpabilities[k].use= string.format("use %s", v.name)
			if UIFrames.abilities[ix].MACRO == nil and tpabilities[k].use ~= nil then
				UIFrames.abilities[ix].MACRO = tpabilities[k].use
				UIFrames.abilities[ix].frame:EventMacroSet(Event.UI.Input.Mouse.Left.Click, tpabilities[k].use)
			end
		end
	end
	
	TP.AlignText(Teleporter_Settings.align)
	
	TP.setpopupOrder()
	TP.AttachPopup()

	UIFrames.mm_button:SetVisible(true)
end

local combatwarning = false

function TP.checkMouse()
	local md = Inspect.Mouse()
	local l = math.min(UIFrames.frame:GetLeft(), UIFrames.mm_button:GetLeft())
	local r = math.max(UIFrames.frame:GetRight(), UIFrames.mm_button:GetRight())
	local t = math.min(UIFrames.frame:GetTop(), UIFrames.mm_button:GetTop())
	local b = math.max(UIFrames.frame:GetBottom(), UIFrames.mm_button:GetBottom())
	
	if md.x < l or md.x > r or md.y < t or md.y > b then
		if Inspect.System.Secure() == false then
			tpmenuVis = false
			UIFrames.frame:SetVisible(false)
			if MINIMAPDOCKER then
				MINIMAPDOCKER.AUTOHIDE_DOCKED = true
			end
		end
	end
end

function TP.UpdateHandler()
	local frcnt = 0
	while true do
		if tpmenuVis == true then
			TP.checkMouse()
		end
		frcnt = frcnt +1
		if frcnt == 10 then
			if tpmenuVis == true then
				for k,v in pairs(tpabilities) do
					local ix = v.p
					local s=""
					local cdr = 0
					if v.able == true then
						if v.type == "spell" then
							local d = Inspect.Ability.New.Detail(k)
							if d ~= nil then
								cdr = d.currentCooldownRemaining or 0
							else
								cdr = nil
							end
						else
							local d = Inspect.Item.Detail(v.id)
							if d ~= nil then
								cdr = d.cooldownRemaining or 0
							else
								cdr = nil
							end
						end
						if cdr ~= nil then
							if cdr > 60 then
								s = string.format("%dm", math.floor(cdr/60))
							elseif cdr > 0 then
								s = string.format("%ds", math.floor(cdr))
							end
							UIFrames.abilities[ix].cdt:SetText(s)
						end
					end
				end
			end
			frcnt = 0
		end
		if UINeeded and playerFound then
			if Inspect.System.Secure() == false then
				if combatwarning then
					print("Out of combat, continuing with setup")
					combatwarning = false
				end
				TP.CreateUI()
				UINeeded = false
			else
				if combatwarning == false then
					print("Setup delayed due to being in combat!")
					combatwarning = true
				end
			end
		elseif SVLoaded and playerFound then
			TP.SVLoaded()
			SVLoaded = false
		end
		coroutine.yield()
	end
end

TP.coUpdateHandler = coroutine.create(TP.UpdateHandler)

function TP.Event_System_Update_Begin(h)
	if coroDead then return end
	local ok, errormsg = coroutine.resume(TP.coUpdateHandler)
	if not ok then
		coroDead = true
		error("Error in coroutine: "..errormsg)
	end
end

function TP.Event_System_Secure_Leave(h)
	if tprebuild then
		TP.setpopupOrder()
	end
end

function TP.Event_System_Secure_Enter(h)
	if tpmenuVis == true then
		UIFrames.frame:SetVisible(false)
		tpmenuVis = false
	end
end

function TP.Event_Unit_Availability_Full(h,t)
	if playerFound then return end
	for	k,v in pairs(t) do
		if v == "player" then
			for k,v in pairs(Inspect.Item.Detail("si")) do
				if _tpitems[v.type] ~= nil then
					itemidcnt = itemidcnt+1
					local vx = _tpitems[v.type]
					default_settings.itemid[vx] = {id = v.id, name = v.name}
					tpabilities[vx].id = v.id
					tpabilities[vx].use = string.format("use %s", v.name)										
					tpabilities[vx].able = true
				end
			end			
			playerFound = true
		end
	end
end

function TP.Command_Slash_Register(h,args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		numargs=numargs+1
		r[numargs] = token
	end
	if r[1] == "mode" then
		if Teleporter_Settings.mode == TPMODE_POPUP then
			Teleporter_Settings.mode = TPMODE_CLICK
			print("Mode set to RIGHT-CLICK")
		else
			Teleporter_Settings.mode = TPMODE_POPUP
			print("Mode set to POPUP")
		end
	elseif r[1] == "align" then
		local p = Teleporter_Settings.align
		if p == "L" then p = "C"
		elseif p == "C" then p = "R"
		elseif p == "R" then p = "L"
		else p = "C"
		end
		Teleporter_Settings.align = p
		TP.AlignText(Teleporter_Settings.align)	
	else
		print("/teleporter mode - Toggles between popup and right-click modes to display selection")
		print("/teleporter align - Cycles between text alignment options C > R > L > C")
	end
end

function TP.Event_Ability_New_Remove(h,t)
	for k,v in pairs(t) do
		if tpabilities[k] then
			for k,v in pairs(tpabilities) do
				if v.type == "spell" then
					tpabilities[k].able = false
				end
			end
			tprebuild = true
			break
		end
	end
	if tprebuild then
		TP.setpopupOrder()
	end
end

function TP.Event_Ability_New_Add(h,t)
	for k,v in pairs(t) do
		if tpabilities[k] then
			local d = Inspect.Ability.New.Detail(k)
			tpabilities[k].icon = d.icon
			tpabilities[k].use = string.format("cast %s", d.name)
			tpabilities[k].able = true
			tprebuild = true
		end
	end
	if tprebuild and UINeeded == false then
		TP.setpopupOrder()
	end
end

---------------------
-- Register Events
---------------------

Command.Event.Attach(Event.System.Update.Begin, TP.Event_System_Update_Begin, "Event.System.Update.Begin")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, function(h,a) if a==addon.identifier then SVLoaded = true end end, "Event.Addon.SavedVariables.Load.End")
Command.Event.Attach(Event.Unit.Availability.Full, TP.Event_Unit_Availability_Full, "Event.Unit.Availability.Full")
Command.Event.Attach(Event.System.Secure.Enter, TP.Event_System_Secure_Enter, "Event.System.Secure.Enter")
Command.Event.Attach(Event.System.Secure.Leave, TP.Event_System_Secure_Leave, "Event.System.Secure.Leave")
Command.Event.Attach(Command.Slash.Register("teleporter"), TP.Command_Slash_Register, "Command.Slash.Register")
Command.Event.Attach(Event.Ability.New.Add, TP.Event_Ability_New_Add, "Event.Ability.New.Add")
Command.Event.Attach(Event.Ability.New.Remove, TP.Event_Ability_New_Remove, "Event.Ability.New.Remove")

print(string.format("v%s loaded.", addon.toc.Version))
